package com.example.mascotaandroid;

import android.content.Intent;
import android.os.Bundle;
import android.support.v7.app.ActionBarActivity;
import android.util.Log;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.Toast;

public class MainActivity extends ActionBarActivity {

	private Button bVerMascota;
	private Button bConfiguracion;
	private Button bAbout;
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_main);
		
		//Inicializar la base de datos
		LogicaNegocio.inicializaBD(this);
		
		//Recuperar elementos
		bVerMascota = (Button) findViewById(R.id.buttonVerMascota);
		bConfiguracion = (Button) findViewById(R.id.buttonConfiguracion);
		bAbout = (Button) findViewById(R.id.buttonAbout);
		
		//Funcionalidad BOTONES
		bVerMascota.setOnClickListener(new OnClickListener() {
			public void onClick(View v) {
				lanzarVerMascota(null);
			}
		});
		bConfiguracion.setOnClickListener(new OnClickListener() {
			public void onClick(View v) {
				lanzarPreferencias(null);
			}
		});
		bAbout.setOnClickListener(new OnClickListener() {
			public void onClick(View v) {
				lanzarAbout(null);
			}
		});
		
		//Lanzamos el servicio que actualiza los estados
		Log.d("GGP","Antes de lanzar servicio");
		Intent i = new Intent(this, ServicioEstadoMascota.class);
		startService(i);
		Log.d("GGP","Despues de lanzar servicio");
	}
	
	/**
	 * Lanza la actividad Mascota
	 * @param view
	 */
	public void lanzarVerMascota(View view){
		Log.d("GGP","MainActivity: lanzarVerMascota");
		Intent i = new Intent(this,MascotaActivity.class);
		Log.d("GGP","MainActivity: lanzarVerMascota - antes de startActivity");
		startActivity(i);
	}
	
	/**
	 * Lanza la actividad Preferencias
	 * @param view
	 */
	public void lanzarPreferencias(View view){
		Intent i = new Intent(this,Preferencias.class);
		startActivity(i);
	}
	
	/**
	 * Lanza la actividad About
	 * @param view
	 */
	public void lanzarAbout(View view){
		Intent i = new Intent(this,About.class);
		startActivity(i);
	}
	

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.main, menu);
		return true;
	}

	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		// Handle action bar item clicks here. The action bar will
		// automatically handle clicks on the Home/Up button, so long
		// as you specify a parent activity in AndroidManifest.xml.
		int id = item.getItemId();
		if (id == R.id.action_settings) {
			return true;
		}
		return super.onOptionsItemSelected(item);
	}
}
