package com.example.mascotaandroid;

import android.content.Context;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteOpenHelper;
import android.util.Log;

public class MascotaDAOSQLite extends SQLiteOpenHelper implements MascotaDAO {

	public MascotaDAOSQLite(Context context) {
		super(context,"porcentajes",null,1);
		// TODO Auto-generated constructor stub
	}

	@Override
	//Aadimos synchronized para que no se pueda llamar a este desde dos procesos a la vez, as aseguramos que se hace el close antes de que se intente volver a usar la conexion
	public synchronized void actualizarPorcentajes(Mascota mascota) {
//		Log.d("GGP","actualizarPorcentajes");
		SQLiteDatabase db = getWritableDatabase();
		db.execSQL("UPDATE porcentajes SET porcentaje = " + mascota.getAlimentacion() + " WHERE id = "+ ID_ALIMENTACION);
		db.execSQL("UPDATE porcentajes SET porcentaje = " + mascota.getDescanso() + " WHERE id = "+ ID_DESCANSO);
		db.execSQL("UPDATE porcentajes SET porcentaje = " + mascota.getFelicidad() + " WHERE id = "+ ID_FELICIDAD);
//		Log.d("GGP","actualizarPorcentajes => close()");
		db.close();
	}

	@Override
	public void onCreate(SQLiteDatabase db) {
		Log.d("GGP","Creacin de la tabla");
		//Creamos la tabla por primera vez
		db.execSQL("CREATE TABLE porcentajes ("+
                "id INTEGER PRIMARY KEY AUTOINCREMENT, "+
                "porcentaje INTEGER)");
		
		//Insertamos un valor inicial para cada porcentaje que se ir actualizando
		db.execSQL("INSERT INTO porcentajes VALUES ( "+ ID_ALIMENTACION+",100)");
        db.execSQL("INSERT INTO porcentajes VALUES ( "+ ID_DESCANSO+",100)");
        db.execSQL("INSERT INTO porcentajes VALUES ( "+ ID_FELICIDAD+",100)");
	}

	@Override
	public void onUpgrade(SQLiteDatabase db, int oldVersion, int newVersion) {
		// Para actualizar las tablas en caso de nueva versin
	}

	@Override
	public synchronized Mascota getEstadoMascota() {
//		Log.d("GGP","MascotaDAOSQLite: getEstadoMascota");
		Mascota mascota = new Mascota();
		
        SQLiteDatabase db = getReadableDatabase();
        Cursor cursor = db.rawQuery("SELECT id, porcentaje FROM porcentajes", null);
        while (cursor.moveToNext()){
        	switch (cursor.getInt(0)) {
	        	case ID_ALIMENTACION:
					mascota.setAlimentacion(cursor.getInt(1));
					break;
	        	case ID_DESCANSO:
					mascota.setDescanso(cursor.getInt(1));
					break;
	        	case ID_FELICIDAD:
					mascota.setFelicidad(cursor.getInt(1));
					break;
	
				default:
					break;
			}
        }
        cursor.close();
        db.close();
		
		return mascota;
	}
	
}
