package com.example.mascotaandroid;

import android.app.IntentService;
import android.content.Intent;
import android.os.SystemClock;
import android.util.Log;

public class ServicioEstadoMascota extends IntentService{

	private static int MILISEGUNTOS_INTERVALO_TIEMPO = 5000;
	
	public ServicioEstadoMascota() {
		super("ServicioEstadoMascota");
	}

	@Override
	protected void onHandleIntent(Intent intent) {
		Log.d("GGP","ServicioEstadoMascota: Hemos arrancado el servicio");
		
		Mascota mascota;
		
		//Bucle para ir cambiando el estado de la mascota con el tiempo
		while(true){
			SystemClock.sleep(MILISEGUNTOS_INTERVALO_TIEMPO);
			mascota = LogicaNegocio.haPasadoIntervaloDeTiempo(this);
			
			//Enviamos la actualizacin mediante un receptro de anuncio para poder actualizar los datos en las vistas
			Intent i = new Intent();
			i.setAction(MascotaActivity.ReceptorActualizacionEstado.ACTION_RESP);
			i.addCategory(Intent.CATEGORY_DEFAULT);
			int[] estado = {mascota.getAlimentacion(),mascota.getDescanso(),mascota.getFelicidad()};
			i.putExtra("estado",estado);
//			Log.d("GGP","ServicioEstadoMascota: Antes de sendBroadcast");
			sendBroadcast(i);
//			Log.d("GGP","ServicioEstadoMascota: Despues de sendBroadcast");
		}
	}

}
